Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Interpreter/IPushInterpreter.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Interpreter/IPushInterpreter.cs	(revision 15016)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Interpreter/IPushInterpreter.cs	(revision 15017)
@@ -20,8 +20,8 @@
     IPushStack<char> CharStack { get; }
     IPushStack<string> StringStack { get; }
-    IPushStack<List<long>> IntegerVectorStack { get; }
-    IPushStack<List<double>> FloatVectorStack { get; }
-    IPushStack<List<bool>> BooleanVectorStack { get; }
-    IPushStack<List<string>> StringVectorStack { get; }
+    IPushStack<IReadOnlyList<long>> IntegerVectorStack { get; }
+    IPushStack<IReadOnlyList<double>> FloatVectorStack { get; }
+    IPushStack<IReadOnlyList<bool>> BooleanVectorStack { get; }
+    IPushStack<IReadOnlyList<string>> StringVectorStack { get; }
     IPushStack<string> PrintStack { get; }
     IDictionary<string, Expression> CustomExpressions { get; }
@@ -30,4 +30,6 @@
     void Clear();
     void Reset();
+
+    void Run(bool stepwise);
     void Run(string code, bool stepwise = false);
     void Run(Expression expression, bool stepwise = false);
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Interpreter/InterpreterPoolContainer.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Interpreter/InterpreterPoolContainer.cs	(revision 15016)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Interpreter/InterpreterPoolContainer.cs	(revision 15017)
@@ -8,5 +8,4 @@
   public class InterpreterPoolContainer {
     private readonly ManagedPoolProvider<PushProgram> pushProgramPoolProvider;
-    private readonly ManagedPoolProvider<LoopState> loopStatePoolProvider;
     private readonly ManagedPoolProvider<PooledList<Expression>> expressionListPoolProvider;
 
@@ -19,5 +18,4 @@
     public InterpreterPoolContainer(int partitionSize = 512, int maxPartitionCount = 1024) {
       pushProgramPoolProvider = new ManagedPoolProvider<PushProgram>(partitionSize, () => new PushProgram(), maxPartitionCount);
-      loopStatePoolProvider = new ManagedPoolProvider<LoopState>(partitionSize, () => new LoopState(), maxPartitionCount);
       expressionListPoolProvider = new ManagedPoolProvider<PooledList<Expression>>(partitionSize, () => new PooledList<Expression>(), maxPartitionCount);
 
@@ -27,8 +25,6 @@
     public InterpreterPoolContainer(
       ManagedPoolProvider<PushProgram> pushProgramPoolProvider,
-      ManagedPoolProvider<LoopState> loopStatePoolProvider,
       ManagedPoolProvider<PooledList<Expression>> expressionListPoolProvider) {
       this.pushProgramPoolProvider = pushProgramPoolProvider;
-      this.loopStatePoolProvider = loopStatePoolProvider;
       this.expressionListPoolProvider = expressionListPoolProvider;
 
@@ -43,14 +39,4 @@
         if (pushProgramPool == null) pushProgramPool = pushProgramPoolProvider.CreatePool();
         return pushProgramPool;
-      }
-    }
-
-    private IManagedPool<LoopState> loopStatePool;
-    public IManagedPool<LoopState> LoopStatePool
-    {
-      get
-      {
-        if (loopStatePool == null) loopStatePool = loopStatePoolProvider.CreatePool();
-        return loopStatePool;
       }
     }
@@ -96,9 +82,4 @@
       }
 
-      if (loopStatePool != null) {
-        loopStatePool.Dispose();
-        loopStatePool = null;
-      }
-
       if (expressionListPool != null) {
         expressionListPool.Dispose();
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Interpreter/PushInterpreter.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Interpreter/PushInterpreter.cs	(revision 15016)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Interpreter/PushInterpreter.cs	(revision 15017)
@@ -5,18 +5,12 @@
   using System.Threading;
   using System.Threading.Tasks;
+  using Attributes;
   using Configuration;
   using Core;
   using Expressions;
-
-  using HeuristicLab.Problems.ProgramSynthesis.Push.Attributes;
-
   using Parser;
   using Random;
   using Stack;
 
-#if DEBUG
-  using System.Diagnostics;
-  using System.Linq;
-#endif
 
   public class PushInterpreter : IInternalPushInterpreter, IDisposable {
@@ -24,6 +18,5 @@
 
     public PushInterpreter(IReadOnlyPushConfiguration config = null, IRandom random = null, InterpreterPoolContainer poolContainer = null) {
-      Random = random ?? new FastRandom();
-
+      Random = random ?? new MersenneTwister();
       Configuration = config ?? new PushConfiguration();
 
@@ -59,17 +52,17 @@
       };
 
-      IntegerVectorStack = new PushStack<List<long>> {
+      IntegerVectorStack = new PushStack<IReadOnlyList<long>> {
         IsEnabled = Configuration.EnabledStacks[StackTypes.IntegerVector]
       };
 
-      FloatVectorStack = new PushStack<List<double>> {
+      FloatVectorStack = new PushStack<IReadOnlyList<double>> {
         IsEnabled = Configuration.EnabledStacks[StackTypes.FloatVector]
       };
 
-      BooleanVectorStack = new PushStack<List<bool>> {
+      BooleanVectorStack = new PushStack<IReadOnlyList<bool>> {
         IsEnabled = Configuration.EnabledStacks[StackTypes.BooleanVector]
       };
 
-      StringVectorStack = new PushStack<List<string>> {
+      StringVectorStack = new PushStack<IReadOnlyList<string>> {
         IsEnabled = Configuration.EnabledStacks[StackTypes.StringVector]
       };
@@ -88,9 +81,9 @@
         { StackTypes.String, StringStack },
         { StackTypes.Name, NameStack },
+        { StackTypes.Print, PrintStack },
         { StackTypes.IntegerVector, IntegerVectorStack },
         { StackTypes.FloatVector, FloatVectorStack },
         { StackTypes.BooleanVector, BooleanVectorStack },
         { StackTypes.StringVector, StringVectorStack },
-        { StackTypes.Print, PrintStack },
       };
 
@@ -160,11 +153,11 @@
     public IPushStack<string> StringStack { get; private set; }
     [PushStack(StackTypes.IntegerVector)]
-    public IPushStack<List<long>> IntegerVectorStack { get; private set; }
+    public IPushStack<IReadOnlyList<long>> IntegerVectorStack { get; private set; }
     [PushStack(StackTypes.FloatVector)]
-    public IPushStack<List<double>> FloatVectorStack { get; private set; }
+    public IPushStack<IReadOnlyList<double>> FloatVectorStack { get; private set; }
     [PushStack(StackTypes.BooleanVector)]
-    public IPushStack<List<bool>> BooleanVectorStack { get; private set; }
+    public IPushStack<IReadOnlyList<bool>> BooleanVectorStack { get; private set; }
     [PushStack(StackTypes.StringVector)]
-    public IPushStack<List<string>> StringVectorStack { get; private set; }
+    public IPushStack<IReadOnlyList<string>> StringVectorStack { get; private set; }
     [PushStack(StackTypes.Print)]
     public IPushStack<string> PrintStack { get; private set; }
@@ -186,4 +179,8 @@
       var program = PushParser.Parse(code);
       Run(program, stepwise);
+    }
+
+    public void Run(bool stepwise) {
+      Run(PushProgram.Empty, stepwise);
     }
 
@@ -322,27 +319,4 @@
     }
 
-#if DEBUG
-    private Expression last;
-    private bool DoStep() {
-      double[] bk;
-      if (!FloatStack.IsEmpty) {
-        bk = FloatStack.Peek(Math.Min(FloatStack.Count, 3));
-      }
-
-      var expression = ExecStack.Pop();
-      var succ = expression.TryEval(this);
-
-      if ((ExecStack.Count > 0 && ExecStack.Top == null) ||
-          (CodeStack.Count > 0 && CodeStack.Top == null) ||
-          FloatStack.Any(x => double.IsNaN(x) || double.IsInfinity(x)) ||
-          StringStack.Count > 0 && StringStack.Any(x => x == null)) {
-        Debugger.Break();
-      }
-
-      ExecCounter++;
-      last = expression;
-      return succ;
-    }
-#else
     [MethodImpl(MethodImplOptions.AggressiveInlining)]
     private bool DoStep() {
@@ -350,5 +324,4 @@
       return ExecStack.Pop().TryEval(this);
     }
-#endif
 
     [MethodImpl(MethodImplOptions.AggressiveInlining)]
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Interpreter/PushInterpreterPool.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Interpreter/PushInterpreterPool.cs	(revision 15016)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Interpreter/PushInterpreterPool.cs	(revision 15017)
@@ -11,5 +11,4 @@
 
     public readonly ManagedPoolProvider<PushProgram> PushProgramPoolProvider;
-    public readonly ManagedPoolProvider<LoopState> LoopStatePoolProvider;
     public readonly ManagedPoolProvider<PooledList<Expression>> ExpressionListPoolProvider;
 
@@ -19,17 +18,16 @@
 
     public PushInterpreterPool(int size, int poolPartitionSize, int? maxPartitionCount = null, IReadOnlyPushConfiguration config = null) {
-      PushGpConfiguration = config ?? new PushConfiguration();
+      PushConfiguration = config ?? new PushConfiguration();
 
       PushProgramPoolProvider = new ManagedPoolProvider<PushProgram>(poolPartitionSize, () => new PushProgram(), maxPartitionCount);
-      LoopStatePoolProvider = new ManagedPoolProvider<LoopState>(poolPartitionSize, () => new LoopState(), maxPartitionCount);
-      ExpressionListPoolProvider = new ManagedPoolProvider<PooledList<Expression>>(poolPartitionSize * 2, () => new PooledList<Expression>(), maxPartitionCount);
+      ExpressionListPoolProvider = new ManagedPoolProvider<PooledList<Expression>>(poolPartitionSize, () => new PooledList<Expression>(), maxPartitionCount);
 
       pool = new ObjectPool<PooledPushInterpreter>(() => {
-        var poolContainer = new InterpreterPoolContainer(PushProgramPoolProvider, LoopStatePoolProvider, ExpressionListPoolProvider);
-        return new PooledPushInterpreter(this, PushGpConfiguration, poolContainer);
+        var poolContainer = new InterpreterPoolContainer(PushProgramPoolProvider, ExpressionListPoolProvider);
+        return new PooledPushInterpreter(this, PushConfiguration, poolContainer);
       }, size);
     }
 
-    public IReadOnlyPushConfiguration PushGpConfiguration { get; private set; }
+    public IReadOnlyPushConfiguration PushConfiguration { get; private set; }
 
     public PooledPushInterpreter Create(IRandom random = null) {
@@ -41,5 +39,11 @@
 
     public void Free(PooledPushInterpreter interpreter) {
+      interpreter.Random = null;
       pool.Free(interpreter);
+    }
+
+    public void Clear() {
+      PushProgramPoolProvider.Clear();
+      ExpressionListPoolProvider.Clear();
     }
   }
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Parser/PushParser.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Parser/PushParser.cs	(revision 15016)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Parser/PushParser.cs	(revision 15017)
@@ -1,13 +1,13 @@
 ﻿namespace HeuristicLab.Problems.ProgramSynthesis.Push.Parser {
+  using System;
   using System.Collections.Generic;
   using System.Globalization;
   using System.Linq;
+  using System.Text.RegularExpressions;
+
+  using HeuristicLab.Problems.ProgramSynthesis.Push.Constants;
   using HeuristicLab.Problems.ProgramSynthesis.Push.Expressions;
 
   public static class PushParser {
-    private const string openBrace = "(";
-
-    private const string closeBrace = ")";
-
     private const char delimiter = ' ';
 
@@ -17,8 +17,9 @@
 
     public static Expression Parse(string source, int startIndex = 0) {
-      var symbols = source.Split(delimiter);
+      bool error;
+      var symbols = GetSymbols(source, out error); // source.Split(delimiter);
 
       int endIndex;
-      return Parse(symbols, 0, out endIndex);
+      return Parse(symbols, startIndex, out endIndex);
     }
 
@@ -29,8 +30,81 @@
     }
 
-    private static Expression Parse(string[] symbols, int startIndex, out int endIndex) {
+    private static IReadOnlyList<string> GetSymbols(string source, out bool error) {
+      var chars = source.ToCharArray();
+      var symbols = new List<string>();
+
+      for (var i = 0; i < chars.Length; i++) {
+        var cur = chars[i];
+        int endIndex;
+        int length;
+        string str;
+
+        switch (cur) {
+          case delimiter: break;
+          case PushEnvironment.StringSymbol:
+            endIndex = source.IndexOf(PushEnvironment.StringSymbol, i + 1);
+            if (endIndex < i) {
+              error = true;
+              return symbols;
+            }
+
+            length = endIndex - i + 1;
+            str = source.Substring(i, length);
+            symbols.Add(str);
+            i += length; // skip following space
+
+            break;
+
+          case PushEnvironment.CharSymbol:
+            endIndex = source.IndexOf(PushEnvironment.CharSymbol, i + 1);
+            if (endIndex < i) {
+              error = true;
+              return symbols;
+            }
+
+            length = endIndex - i + 1;
+            str = source.Substring(i, length);
+            str = EscapeLikeALiteral(str);
+            symbols.Add(str);
+            i += length; // skip following space
+
+            break;
+
+          case PushEnvironment.VectorStartSymbol:
+            endIndex = source.IndexOf(PushEnvironment.VectorEndSymbol, i + 1);
+            if (endIndex < i) {
+              error = true;
+              return symbols;
+            }
+
+            length = endIndex - i + 1;
+            str = source.Substring(i, length);
+            symbols.Add(str);
+            i += length; // skip following space
+            break;
+
+          default:
+            endIndex = source.IndexOf(' ', i + 1);
+
+            length = endIndex < i
+              ? chars.Length - i
+              : endIndex - i;
+
+            str = source.Substring(i, length);
+            symbols.Add(str);
+            i += length; // skip following space
+
+            break;
+        }
+      }
+
+      error = true;
+      return symbols;
+    }
+
+    private static Expression Parse(IReadOnlyList<string> symbols, int startIndex, out int endIndex) {
       var expressions = new List<Expression>();
 
-      for (var i = startIndex; i < symbols.Length; i++) {
+      for (var i = startIndex; i < symbols.Count; i++) {
         var symbol = symbols[i].TrimEnd(symbolTrim);
 
@@ -38,10 +112,10 @@
 
         switch (symbol) {
-          case openBrace:
+          case PushEnvironment.ProgramStartSymbolStr:
             var subExpression = Parse(symbols, i + 1, out endIndex);
             expressions.Insert(0, subExpression);
             i = endIndex;
             continue;
-          case closeBrace:
+          case PushEnvironment.ProgramEndSymbolStr:
             endIndex = i;
             return new PushProgram(expressions);
@@ -66,5 +140,5 @@
       }
 
-      endIndex = symbols.Length - 1;
+      endIndex = symbols.Count - 1;
 
       switch (expressions.Count) {
@@ -79,25 +153,26 @@
 
     private static bool TryParseLiteral(string word, out Expression expression) {
-      if (word.StartsWith("'") && word.EndsWith("'") && word.Length == 3) {
-        expression = new CharPushExpression(word[1]);
-        return true;
-      }
-
-      if (word.StartsWith("\"") && word.EndsWith("\"")) {
-        expression = new StringPushExpression(word);
-        return true;
-      }
-
-      // "[]" has no values and can therefer not parsed correctly as vector of a specific type
-      if (word.StartsWith("[") && word.EndsWith("]") && word.Length > 3) {
+      if (word.StartsWith(PushEnvironment.CharSymbolStr) &&
+          word.EndsWith(PushEnvironment.CharSymbolStr) &&
+          word.Length == 3) {
+          expression = new CharPushExpression(word[1]);
+          return true;
+      }
+
+      if (word.StartsWith(PushEnvironment.StringSymbolStr) &&
+          word.EndsWith(PushEnvironment.StringSymbolStr)) {
+        var stringValue = word.Length == 0 ? string.Empty : word.Substring(1, word.Length - 2);
+        expression = new StringPushExpression(stringValue);
+        return true;
+      }
+
+      // "[]" has no values and can therefor not parsed correctly as vector of a specific type
+      if (word.StartsWith(PushEnvironment.VectorStartSymbolStr) &&
+          word.EndsWith(PushEnvironment.VectorEndSymbolStr) &&
+          word.Length > 2) {
+
         var vectorEntries = word
           .Substring(1, word.Length - 2)
-          .Split(',')
-          .Select(x => {
-            Expression e;
-            var success = TryParseLiteral(x.Trim(), out e);
-
-            return new { success, e, type = e.GetType() };
-          })
+          .Split(PushEnvironment.VectorSeparatorSymbol)
           .ToArray();
 
@@ -107,22 +182,29 @@
         }
 
-        var vectorEntryType = vectorEntries.First().type;
-        if (vectorEntries.Any(x => !x.success || x.type != vectorEntryType)) {
+        Expression e;
+        var first = vectorEntries.First();
+        if (!TryParseLiteral(first, out e)) {
           expression = null;
           return false;
         }
 
-        var result = vectorEntries
-          .Select(x => x.e)
-          .ToArray();
-
-        // TODO
-        //switch(vectorEntryType.GetHashCode())
-        //{
-        //  case typeof(IntegerPushExpression).GetHashCode(): return new IntegerVectorPushExpression(result)
-        //}
-
-        //expression = new StringPushExpression(word);
-        //return true;
+        if (e.GetType() == typeof(IntegerPushExpression)) {
+          var integerValues = vectorEntries.Select(long.Parse).ToArray();
+          expression = new IntegerVectorPushExpression(integerValues);
+        } else if (e.GetType() == typeof(FloatPushExpression)) {
+          var doubleValues = vectorEntries.Select(x => double.Parse(x, NumberStyles.Float, cultureInfo)).ToArray();
+          expression = new FloatVectorPushExpression(doubleValues);
+        } else if (e.GetType() == typeof(StringPushExpression)) {
+          var stringValues = vectorEntries.Select(str => str.Substring(1, str.Length - 2)).ToArray();
+          expression = new StringVectorPushExpression(stringValues);
+        } else if (e.GetType() == typeof(BooleanPushExpression)) {
+          var booleanValues = vectorEntries.Select(bool.Parse).ToArray();
+          expression = new BooleanVectorPushExpression(booleanValues);
+        } else {
+          expression = null;
+          return false;
+        }
+
+        return true;
       }
 
@@ -148,4 +230,24 @@
       return false;
     }
+
+    private static string EscapeLikeALiteral(string src) {
+      return Regex.Replace(src, @"\\(?<simple>['""\\0abfnrtv])", m => {
+        var s = m.Groups["simple"].Value;
+        switch (s) {
+          case "'": return "'";
+          case "\"": return "\"";
+          case "0": return "\0";
+          case "a": return "\a";
+          case "b": return "\b";
+          case "f": return "\f";
+          case "n": return "\n";
+          case "r": return "\r";
+          case "t": return "\t";
+          case "v": return "\v";
+          default:
+            throw new InvalidOperationException();
+        }
+      });
+    }
   }
 }
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Problem/BenchmarkSuite/BenchmarkSuitePushSolutionView.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Problem/BenchmarkSuite/BenchmarkSuitePushSolutionView.cs	(revision 15016)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Problem/BenchmarkSuite/BenchmarkSuitePushSolutionView.cs	(revision 15017)
@@ -10,4 +10,5 @@
   using HeuristicLab.BenchmarkSuite.Views;
   using HeuristicLab.Common;
+  using HeuristicLab.Problems.ProgramSynthesis.Push.Constants;
 
   using Interpreter;
@@ -237,7 +238,5 @@
 
         case ExampleArgumentType.Print:
-          var requiredLines = example.OutputPrint.Split(new[] { Environment.NewLine }, StringSplitOptions.None).Length;
-          var count = Math.Min(requiredLines, interpreter.PrintStack.Count);
-          return string.Join(valueSeparator, string.Join(Environment.NewLine, interpreter.PrintStack.Peek(count)));
+          return string.Join(valueSeparator, string.Join(PushEnvironment.NewLine, interpreter.PrintStack.Take(example.OutputPrintLineCount)));
 
         case ExampleArgumentType.String:
@@ -257,16 +256,8 @@
     }
 
-    private static string GetVectorEntryAsString<T>(int offset, IPushStack<List<T>> vectorStack) {
+    private static string GetVectorEntryAsString<T>(int offset, IPushStack<IReadOnlyList<T>> vectorStack) {
       return vectorStack.Count > offset
        ? "[" + string.Join(",", vectorStack[offset]) + "]"
        : string.Empty;
-    }
-
-    private int GetCount<T>(IPushStack<T> stack, T[] data) {
-      return Math.Max(0, Math.Min(data.Length, stack.Count));
-    }
-
-    private int GetVectorCount<T>(IPushStack<List<T>> stack, T[][] data) {
-      return Math.Max(0, Math.Min(data.Length, stack.Count));
     }
 
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Problem/BenchmarkSuite/PushBenchmarkSuiteEvaluator.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Problem/BenchmarkSuite/PushBenchmarkSuiteEvaluator.cs	(revision 15016)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Problem/BenchmarkSuite/PushBenchmarkSuiteEvaluator.cs	(revision 15017)
@@ -12,4 +12,5 @@
   using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
   using HeuristicLab.Problems.ProgramSynthesis.Push.Configuration;
+  using HeuristicLab.Problems.ProgramSynthesis.Push.Constants;
 
   using Interpreter;
@@ -78,5 +79,5 @@
     }
 
-    public EvaluationResult Evaluate(IPushInterpreter interpreter, PushProgram program, IRandom random, int start, int end) {
+    public EvaluationResult Evaluate(IPushInterpreter interpreter, PushProgram program, int start, int end) {
       var length = end - start;
       if (length <= 0) return null;
@@ -87,40 +88,40 @@
         var result = Evaluate(interpreter, program, i);
         evaluationResult.ExampleQualities[i - start] = result;
-        evaluationResult.TotalQuality += result;
+        evaluationResult.AvgQuality += result;
         interpreter.Reset();
       }
 
-      evaluationResult.TotalQuality /= length;
+      evaluationResult.AvgQuality /= length;
 
       return evaluationResult;
     }
 
-    public EvaluationResult EvaluateTest(IPushInterpreter interpreter, PushProgram program, IRandom random) {
-      return Evaluate(interpreter, program, random, DataBounds.TestRange.Start, DataBounds.TestRange.End);
+    public EvaluationResult EvaluateTest(IPushInterpreter interpreter, PushProgram program) {
+      return Evaluate(interpreter, program, DataBounds.TestRange.Start, DataBounds.TestRange.End);
     }
 
     public EvaluationResult EvaluateTest(IReadOnlyPushConfiguration config, PushProgram program, IRandom random) {
       var interpreter = new PushInterpreter(config, random);
-      return EvaluateTest(interpreter, program, random);
+      return EvaluateTest(interpreter, program);
     }
 
     public EvaluationResult EvaluateTest(PushInterpreterPool pool, PushProgram program, IRandom random) {
       using (var interpreter = pool.Create(random)) {
-        return EvaluateTest(interpreter, program, random);
-      }
-    }
-
-    public EvaluationResult EvaluateTraining(IPushInterpreter interpreter, PushProgram program, IRandom random) {
-      return Evaluate(interpreter, program, random, DataBounds.TrainingRange.Start, DataBounds.TrainingRange.End);
+        return EvaluateTest(interpreter, program);
+      }
+    }
+
+    public EvaluationResult EvaluateTraining(IPushInterpreter interpreter, PushProgram program) {
+      return Evaluate(interpreter, program, DataBounds.TrainingRange.Start, DataBounds.TrainingRange.End);
     }
 
     public EvaluationResult EvaluateTraining(IReadOnlyPushConfiguration config, PushProgram program, IRandom random) {
       var interpreter = new PushInterpreter(config, random);
-      return EvaluateTraining(interpreter, program, random);
+      return EvaluateTraining(interpreter, program);
     }
 
     public EvaluationResult EvaluateTraining(PushInterpreterPool pool, PushProgram program, IRandom random) {
       using (var interpreter = pool.Create(random)) {
-        return EvaluateTraining(interpreter, program, random);
+        return EvaluateTraining(interpreter, program);
       }
     }
@@ -134,18 +135,32 @@
       interpreter.CharStack.Push(example.InputChar);
       interpreter.StringStack.Push(example.InputString);
-      interpreter.StringVectorStack.Push(example.InputStringVector.Select(v => new List<string>(v)));
-      interpreter.IntegerVectorStack.Push(example.InputIntegerVector.Select(v => new List<long>(v)));
-      interpreter.FloatVectorStack.Push(example.InputFloatVector.Select(v => new List<double>(v)));
+      interpreter.StringVectorStack.Push(example.InputStringVector);
+      interpreter.IntegerVectorStack.Push(example.InputIntegerVector);
+      interpreter.FloatVectorStack.Push(example.InputFloatVector);
 
       interpreter.Run(program);
 
+      switch (Data.ProblemType) {
+        //case ProblemType.NumberIO:
+        //  if (interpreter.PrintStack.IsEmpty)
+        //    return Data.WorstResult;
+
+        //  double value;
+        //  var levenshteinDistance = GetPrintDiffer(example.OutputPrint, interpreter.PrintStack, example.OutputPrintLineCount, Data.WorstResult);
+        //  return levenshteinDistance + (double.TryParse(interpreter.PrintStack.Top, out value)
+        //    ? FloatDiffer(value, example.OutputFloat[0], example.OutputFloatPrecision)
+        //    : Data.WorstResult / 2);
+
+        case ProblemType.Median: return interpreter.PrintStack.IsEmpty ? 1 : interpreter.PrintStack.Top.Equals(example.OutputPrint) ? 0 : 1;
+      }
+
       var result = GetDiff(example.OutputInteger, interpreter.IntegerStack, Data.WorstResult, IntegerDiffer)
-                 + GetDiff(example.OutputFloat, interpreter.FloatStack, Data.WorstResult, FloatDiffer)
+                 + GetDiff(example.OutputFloat, interpreter.FloatStack, Data.WorstResult, (a, b) => FloatDiffer(a, b, example.OutputFloatPrecision))
                  + GetDiff(example.OutputBoolean, interpreter.BooleanStack, Data.WorstResult, BooleanDiffer)
                  + GetDiff(example.OutputString, interpreter.StringStack, Data.WorstResult, StringDiffer)
                  + GetDiff(example.OutputChar, interpreter.CharStack, Data.WorstResult, CharDiffer)
-                 + GetPrintDiffer(example.OutputPrint, interpreter.PrintStack)
+                 + GetPrintDiffer(example.OutputPrint, interpreter.PrintStack, example.OutputPrintLineCount, Data.WorstResult)
                  + GetVectorDiff(example.OutputIntegerVector, interpreter.IntegerVectorStack, Data.WorstResult, (a, b) => VectorDiffer(a, b, IntegerDiffer))
-                 + GetVectorDiff(example.OutputFloatVector, interpreter.FloatVectorStack, Data.WorstResult, (a, b) => VectorDiffer(a, b, FloatDiffer))
+                 + GetVectorDiff(example.OutputFloatVector, interpreter.FloatVectorStack, Data.WorstResult, (a, b) => VectorDiffer(a, b, (x, y) => FloatDiffer(x, y, example.OutputFloatVectorPrecision)))
                  + GetVectorDiff(example.OutputStringVector, interpreter.StringVectorStack, Data.WorstResult, (a, b) => VectorDiffer(a, b, StringDiffer));
 
@@ -153,11 +168,13 @@
     }
 
-    private static double FloatDiffer(double a, double b) {
-      var result = a - b;
-
-      if (result.IsAlmost(double.MinValue) || double.IsPositiveInfinity(result) || double.IsNaN(result))
+    private static double FloatDiffer(double a, double b, int digits) {
+      var result = Math.Round(a, digits) - Math.Round(b, digits);
+
+      // ReSharper disable once CompareOfFloatsByEqualityOperator
+      if (result == double.MinValue || double.IsPositiveInfinity(result) || double.IsNaN(result))
         return double.MaxValue;
 
-      if (result.IsAlmost(double.MaxValue) || double.IsNegativeInfinity(result))
+      // ReSharper disable once CompareOfFloatsByEqualityOperator
+      if (result == double.MaxValue || double.IsNegativeInfinity(result))
         return double.MinValue;
 
@@ -200,13 +217,12 @@
     }
 
-    private static readonly string[] separator = { "\n" };
-    private static double GetPrintDiffer(string estimated, IPushStack<string> printStack) {
-      var estimatedCount = estimated.Split(separator, StringSplitOptions.None).Length;
-      var printResult = string.Join(separator[0], printStack.Take(estimatedCount));
-
-      return LevenshteinDistance(estimated, printResult);
-    }
-
-    private static double GetVectorDiff<T>(IReadOnlyList<IReadOnlyList<T>> estimated, IPushStack<List<T>> resultStack, double worstResult, Func<IReadOnlyList<T>, IReadOnlyList<T>, double> differ)
+    private static double GetPrintDiffer(string estimated, IPushStack<string> printStack, int estimatedCount, double worstResult) {
+      var printResult = string.Join(PushEnvironment.NewLine, printStack.Take(estimatedCount));
+      var distance = LevenshteinDistance(estimated, printResult);
+
+      return Math.Min(distance, worstResult);
+    }
+
+    private static double GetVectorDiff<T>(IReadOnlyList<IReadOnlyList<T>> estimated, IPushStack<IReadOnlyList<T>> resultStack, double worstResult, Func<IReadOnlyList<T>, IReadOnlyList<T>, double> differ)
       where T : IComparable {
       if (estimated.Count == 0) return 0d;
